#!/usr/bin/env python
# coding: utf-8

# In[3]:


import numpy as np
import scipy.optimize as spo
from matplotlib import pyplot as plt   
plt.rcParams['axes.grid'] = True       
plt.rcParams['savefig.format'] = 'png' 


# In[4]:


def f(x,p):
    a,b = p
    return a*x+b

def Dx_f(x,p):
    a,b = p
    return a

def residual(p,y,x,uy,ux):
    return (y-f(x,p))/np.sqrt(uy**2 +(Dx_f(x,p)*ux)**2)


# In[78]:


T1 = 

P1 = np.array([])*10**5 #Pa
V1 = np.array([])*10**(-6) #m^3
uP1 = np.full(len(P1), 0.25) *10**5 
uV1 = np.full(len(V1), 0.025)*10**(-6)

x1 = 1/V1
y1 = P1*V1
ux1= uV1/(V1**2)
uy1= y1*np.sqrt(((uP1/P1)**2)+((uV1/V1)**2))

p0 = np.array([0.1,0.1])*10**(-6)
result1 = spo.leastsq(residual,p0,args=(y1,x1,uy1,ux1), full_output=True)
popt1 = result1[0]
pcov1 = result1[1]
upopt1 = np.sqrt(np.abs(np.diagonal(pcov1)))

plt.figure(figsize=(16,8))
x_mod1 = np.linspace(np.amin(x1),np.amax(x1),1000)
y_mod1 = f(x_mod1,popt1)
plt.plot(x_mod1,y_mod1,label='Modèle affine $y = a x + b$', color = 'blue', linestyle= '-')
plt.errorbar(x1,y1,xerr=ux1,yerr=uy1,marker='+', color = 'red', linestyle= '',label='Points pris en préparation')
plt.xlabel('Abscisse à définir',fontsize=32)
plt.ylabel('Ordonnée à définir',fontsize=32)
plt.xticks(fontsize=32)
plt.yticks(fontsize=32)
plt.legend(loc='upper right',fontsize=25)
plt.text(350000,3.0, 'Ordonnée à l\'origine = ' + str(round(popt1[1],3)) + ' ± ' + str(round(upopt1[1],3)) + ' j',fontsize=16)
plt.show()


# In[79]:


T2 =  # °C

P2 = np.array([])*10**5 #Pa
V2 = np.array([])*10**(-6) #m^3
uP2 = np.full(len(P2), 0.25)*10**5 
uV2 = np.full(len(V2), 0.025)*10**(-6) 

x2 = 1/V2
y2 = P2*V2
ux2= uV2/(V2**2)
uy2= y2*np.sqrt(((uP2/P2)**2)+((uV2/V2)**2))

p0 = np.array([0.1,0.1])*10**(-6)
result2 = spo.leastsq(residual,p0,args=(y2,x2,uy2,ux2), full_output=True)
popt2 = result2[0]
pcov2 = result2[1]
upopt2 = np.sqrt(np.abs(np.diagonal(pcov2)))

plt.figure(figsize=(16,8))
x_mod2 = np.linspace(np.amin(x2),np.amax(x2),1000)
y_mod2 = f(x_mod2,popt2)
plt.plot(x_mod2,y_mod2,label='Modèle affine $y = a x + b$', color = 'blue', linestyle= '-')
plt.errorbar(x2,y2,xerr=ux2,yerr=uy2,marker='+', color = 'red', linestyle= '',label='Points pris en préparation')
plt.xlabel('Abscisse à définir',fontsize=32)
plt.ylabel('Ordonnée à définir',fontsize=32)
plt.xticks(fontsize=32)
plt.yticks(fontsize=32)
#plt.xlim(0.9*np.amin(x2), 1.01*np.amax(x2))
#plt.ylim(0.9*np.amin(y2), 1.01*np.amax(y2))
plt.legend(loc='upper right',fontsize=25)
plt.text(350000,3.0, 'Ordonnée à l\'origine = ' + str(round(popt2[1],3)) + ' ± ' + str(round(upopt2[1],3)) + ' J',fontsize=16)
plt.show()


# In[80]:


T3 =  # °C

P3 = np.array([])*10**5 #Pa
V3 = np.array([])*10**(-6) #m^3
uP3 = np.full(len(P3), 0.25)*10**5 
uV3 = np.full(len(V3), 0.025)*10**(-6) 

x3 = 1/V3
y3 = P3*V3
ux3= uV3/(V3**2)
uy3= y3*np.sqrt(((uP3/P3)**2)+((uV3/V3)**2))

p0 = np.array([0.1,0.1])*10**(-6)
result3 = spo.leastsq(residual,p0,args=(y3,x3,uy3,ux3), full_output=True)
popt3 = result3[0]
pcov3 = result3[1]
upopt3 = np.sqrt(np.abs(np.diagonal(pcov3)))

plt.figure(figsize=(16,8))
x_mod3 = np.linspace(np.amin(x3),np.amax(x3),1000)
y_mod3 = f(x_mod3,popt3)
plt.plot(x_mod3,y_mod3,label='Modèle affine $y = a x + b$', color = 'blue', linestyle= '-')
plt.errorbar(x3,y3,xerr=ux3,yerr=uy3,marker='+', color = 'red', linestyle= '',label='Points pris en préparation')
plt.xlabel('Abscisse à définir',fontsize=32)
plt.ylabel('Ordonnée à définir',fontsize=32)
plt.xticks(fontsize=32)
plt.yticks(fontsize=32)
#plt.xlim(0.9*np.amin(x3), 1.01*np.amax(x3))
#plt.ylim(0.9*np.amin(y3), 1.01*np.amax(y3))
plt.legend(loc='upper right',fontsize=25)
plt.text(350000,3.0, 'Ordonnée à l\'origine = ' + str(round(popt3[1],3)) + ' ± ' + str(round(upopt3[1],3)) + ' J',fontsize=16)
plt.show()


# In[81]:


T4 = # °C

P4 = np.array([])*10**5 #Pa
V4 = np.array([])*10**(-6) #m^3
uP4 = np.full(len(P4), 0.25)*10**5 #bar
uV4 = np.full(len(V4), 0.025)*10**(-6) #mL

print(len(P4),len(V4))
x4 = 1/V4
y4 = P4*V4
ux4= uV4/(V4**2)
uy4= y4*np.sqrt(((uP4/P4)**2)+((uV4/V4)**2))

p0 = np.array([0.1,0.1])*10**(-6)
result4 = spo.leastsq(residual,p0,args=(y4,x4,uy4,ux4), full_output=True)
popt4 = result4[0]
pcov4 = result4[1]
upopt4 = np.sqrt(np.abs(np.diagonal(pcov4)))

plt.figure(figsize=(16,8))
x_mod4 = np.linspace(np.amin(x4),np.amax(x4),1000)
y_mod4 = f(x_mod4,popt4)
plt.plot(x_mod4,y_mod4,label='Modèle affine $y = a x + b$', color = 'blue', linestyle= '-')
plt.errorbar(x4,y4,xerr=ux4,yerr=uy4,marker='+', color = 'red', linestyle= '',label='Points pris en préparation')
plt.xlabel('Abscisse à définir',fontsize=32)
plt.ylabel('Ordonnée à définir',fontsize=32)
plt.xticks(fontsize=32)
plt.yticks(fontsize=32)
#plt.xlim(0.9*np.amin(x4), 1.01*np.amax(x4))
#plt.ylim(0.9*np.amin(y4), 1.01*np.amax(y4))
plt.legend(loc='upper right',fontsize=25)
plt.text(350000,3.3, 'Ordonnée à l\'origine = ' + str(round(popt4[1],3)) + ' ± ' + str(round(upopt4[1],3)) + ' J',fontsize=16)
plt.show()


# In[82]:


T5 = # °C

P5 = np.array([])*10**5 #Pa
V5 = np.array([])*10**(-6) #m^3
uP5 = np.full(len(P5), 0.25)*10**5 #bar
uV5 = np.full(len(V5), 0.025)*10**(-6) #mL

print(len(P5),len(V5))
x5 = 1/V5
y5 = P5*V5
ux5= uV5/(V5**2)
uy5= y5*np.sqrt(((uP5/P5)**2)+((uV5/V5)**2))

p0 = np.array([0.1,0.1])*10**(-6)
result5 = spo.leastsq(residual,p0,args=(y5,x5,uy5,ux5), full_output=True)
popt5 = result5[0]
pcov5 = result5[1]
upopt5 = np.sqrt(np.abs(np.diagonal(pcov5)))

plt.figure(figsize=(16,8))
x_mod5 = np.linspace(np.amin(x5),np.amax(x5),1000)
y_mod5 = f(x_mod5,popt5)
plt.plot(x_mod5,y_mod5,label='Modèle affine $y = a x + b$', color = 'blue', linestyle= '-')
plt.errorbar(x5,y5,xerr=ux5,yerr=uy5,marker='+', color = 'red', linestyle= '',label='Points pris en préparation')
plt.xlabel('Abscisse à définir',fontsize=32)
plt.ylabel('Ordonnée à définir',fontsize=32)
plt.xticks(fontsize=32)
plt.yticks(fontsize=32)
#plt.xlim(0.9*np.amin(x5), 1.01*np.amax(x5))
#plt.ylim(0.9*np.amin(y5), 1.01*np.amax(y5))
plt.legend(loc='upper right',fontsize=25)
plt.text(350000,3.4, 'Ordonnée à l\'origine = ' + str(round(popt5[1],3)) + ' ± ' + str(round(upopt5[1],3)) + ' J',fontsize=16)
plt.show()


# In[110]:


T6 = # °C

P6 = np.array([])*10**5 #Pa
V6 = np.array([])*10**(-6) #m^3
uP6 = np.full(len(P6), 0.25)*10**5 #bar
uV6 = np.full(len(V6), 0.025)*10**(-6) #mL

print(len(P6),len(V6))
x6 = 1/V6
y6 = P6*V6
ux6= uV6/(V6**2)
uy6= y6*np.sqrt(((uP6/P6)**2)+((uV6/V6)**2))

p0 = np.array([0.1,0.1])*10**(-6)
result6 = spo.leastsq(residual,p0,args=(y6,x6,uy6,ux6), full_output=True)
popt6 = result6[0]
pcov6 = result6[1]
upopt6 = np.sqrt(np.abs(np.diagonal(pcov6)))

plt.figure(figsize=(16,8))
x_mod6 = np.linspace(np.amin(x6),np.amax(x6),1000)
y_mod6 = f(x_mod6,popt6)
plt.plot(x_mod6,y_mod6,label='Modèle affine $y = a x + b$', color = 'blue', linestyle= '-')
plt.errorbar(x6,y6,xerr=ux6,yerr=uy6,marker='+', color = 'red', linestyle= '',label='Points pris en préparation')
plt.xlabel('$\\frac{1}{V}~(~m^{-3}~)$',fontsize=32)
plt.ylabel('$PV~(~J~)$',fontsize=32)
plt.xticks(fontsize=32)
plt.yticks(fontsize=32)
#plt.xlim(0.9*np.amin(x6), 1.01*np.amax(x6))
#plt.ylim(0.9*np.amin(y6), 1.01*np.amax(y6))
plt.legend(loc='upper right',fontsize=25)
plt.text(350000,3.5, 'Ordonnée à l\'origine = ' + str(round(popt6[1],3)) + ' ± ' + str(round(upopt6[1],3)) + ' J',fontsize=16)
plt.show()


# In[115]:


T7 = # °C

P7 = np.array([])*10**5 #Pa
V7 = np.array([])*10**(-6) #m^3
uP7 = np.full(len(P7), 0.25)*10**5 #bar
uV7 = np.full(len(V7), 0.025)*10**(-6) #mL

print(len(P7),len(V7))
x7 = 1/V7
y7 = P7*V7
ux7= uV7/(V7**2)
uy7= y7*np.sqrt(((uP7/P7)**2)+((uV7/V7)**2))

p0 = np.array([0.1,0.1])*10**(-6)
result7 = spo.leastsq(residual,p0,args=(y7,x7,uy7,ux7), full_output=True)
popt7 = result7[0]
pcov7 = result7[1]
upopt7 = np.sqrt(np.abs(np.diagonal(pcov7)))

plt.figure(figsize=(16,8))
x_mod7 = np.linspace(np.amin(x7),np.amax(x7),1000)
y_mod7 = f(x_mod7,popt7)
plt.plot(x_mod7,y_mod7,label='Modèle affine $y = a x + b$', color = 'blue', linestyle= '-')
plt.errorbar(x7,y7,xerr=ux7,yerr=uy7,marker='+', color = 'red', linestyle= '',label='Points pris en préparation')
plt.xlabel('$\\frac{1}{V}~(~m^{-3}~)$',fontsize=32)
plt.ylabel('$PV~(~J~)$',fontsize=32)
plt.xticks(fontsize=32)
plt.yticks(fontsize=32)
#plt.xlim(0.9*np.amin(x7), 1.01*np.amax(x7))
#plt.ylim(0.9*np.amin(y7), 1.01*np.amax(y7))
plt.legend(loc='upper right',fontsize=25)
plt.text(350000,3.7, 'Ordonnée à l\'origine = ' + str(round(popt7[1],3)) + ' ± ' + str(round(upopt7[1],3)) + ' J',fontsize=16)
plt.show()


# In[117]:


plt.figure(figsize=(16,8))

plt.errorbar(x1,y1,xerr=ux1,yerr=uy1,marker='+', color = 'r', linestyle= '',label='T1 = 19.8°C')
plt.plot(x_mod1,y_mod1,label='Modèle affine $y = a x + b$', color = 'r', linestyle= '-')
plt.errorbar(x2,y2,xerr=ux2,yerr=uy2,marker='+', color = 'b', linestyle= '',label='T2 = 24.6°C')
plt.plot(x_mod2,y_mod2,label='Modèle affine $y = a x + b$', color = 'b', linestyle= '-')
plt.errorbar(x3,y3,xerr=ux3,yerr=uy3,marker='+', color = 'g', linestyle= '',label='T3 = 29.2°C')
plt.plot(x_mod3,y_mod3,label='Modèle affine $y = a x + b$', color = 'g', linestyle= '-')
plt.errorbar(x4,y4,xerr=ux4,yerr=uy4,marker='+', color = 'c', linestyle= '',label='T4 = 34.1°C')
plt.plot(x_mod4,y_mod4,label='Modèle affine $y = a x + b$', color = 'c', linestyle= '-')
plt.errorbar(x5,y5,xerr=ux5,yerr=uy5,marker='+', color = 'm', linestyle= '',label='T5 = 38.8°C')
plt.plot(x_mod5,y_mod5,label='Modèle affine $y = a x + b$', color = 'm', linestyle= '-')
plt.errorbar(x6,y6,xerr=ux6,yerr=uy6,marker='+', color = 'y', linestyle= '',label='T6 = 43.7°C')
plt.plot(x_mod6,y_mod6,label='Modèle affine $y = a x + b$', color = 'y', linestyle= '-')
plt.errorbar(x7,y7,xerr=ux7,yerr=uy7,marker='+', color = 'black', linestyle= '',label='T7 = 48.2°C')
plt.plot(x_mod7,y_mod7,label='Modèle affine $y = a x + b$', color = 'black', linestyle= '-')
plt.xlim(260000,800000)
plt.legend(loc='upper right',fontsize=12)
plt.xlabel('$\\frac{1}{V}~(~m^{-3}~)$',fontsize=32)
plt.ylabel('$PV~(~J~)$',fontsize=32)
plt.xticks(fontsize=32)
plt.yticks(fontsize=32)
plt.show()


# In[118]:


x = np.array([T1,T2,T3,T4,T5,T6]) + 273.15
ux = np.full(len(x),0.1)
y = np.array([popt1[1],popt2[1],popt3[1],popt4[1],popt5[1],popt6[1]])
uy = np.array([upopt1[1],upopt2[1],upopt3[1],upopt4[1],upopt5[1],upopt6[1]])

x_exp = np.array([T7])  + 273.15
ux_exp= np.array([0.001])
y_exp = np.array([popt7[1]])
uy_exp= np.array([upopt7[1]])

x = np.concatenate((x,x_exp))
y = np.concatenate((y,y_exp))
ux= np.concatenate((ux,ux_exp))
uy= np.concatenate((uy,uy_exp))

p0 = np.array([0.1,0.1])
result = spo.leastsq(residual,p0,args=(y,x,uy,ux), full_output=True)
popt = result[0]
pcov = result[1]
upopt = np.sqrt(np.abs(np.diagonal(pcov)))

plt.figure(figsize=(16,8))
x_mod = np.linspace(np.amin(x),np.amax(x),1000)
y_mod = f(x_mod,popt)
plt.plot(x_mod,y_mod,label='Modèle affine $y = a x + b$', color = 'blue', linestyle= '-')
plt.errorbar(x,y,xerr=ux,yerr=uy,marker='+', color = 'red', linestyle= '',label='Points pris en préparation')
plt.errorbar(x_exp,y_exp,xerr=ux_exp,yerr=uy_exp,marker='+', color = 'green', linestyle= '',label='Points pris en live')
plt.xlabel('Température T (K)',fontsize=32)
plt.ylabel('nRT (J)',fontsize=32)
plt.xticks(fontsize=32)
plt.yticks(fontsize=32)
#plt.xlim(0.9*np.amin(x7), 1.01*np.amax(x7))
#plt.ylim(0.9*np.amin(y7), 1.01*np.amax(y7))
plt.legend(loc='upper left',fontsize=25)
plt.text(301,4.03, 'Sensibilité nR = ' + str(round(popt[0],3)) + ' ± ' + str(round(upopt[0],3)) + ' J/K',fontsize=16)
plt.text(301,3.97, 'Ordonnée à l\'origine = ' + str(round(popt[1],3)) + ' ± ' + str(round(upopt[1],3)) + ' J',fontsize=16)
plt.text(301,3.92, 'Résolution = $\\frac{u(nRT)}{nR} \sim$' + str(round(0.1/popt[0],0)) + ' K',fontsize=16)
plt.show()


# In[123]:


n = popt[0]/8.314
print(n)


# In[ ]:




